package configgui.fi_jn;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;

import configgui.java.Rcc;
import configgui.java.commands.Command;

public class DistributionCommand extends Command {

	private String opt; // XXX @author CS
	private String helpString;

	public DistributionCommand(String opt) {
		this.opt = opt;
		try {
			helpString = readFile("src/configgui/resources/readmes/distributions", StandardCharsets.UTF_8);
		} catch (IOException e) {
			Rcc.out.addException(e);
		}
	}

	@Override
	protected void executeCommand() {
		if (opt == null) {
			Rcc.out.terminalPrintln(helpString, 1);
		} else {
			// FIXME cmd specific help
		}
	}

	@Override
	public boolean validate() {
		return Rcc.out != null;
	}

	static String readFile(String path, Charset encoding) throws IOException {
		byte[] encoded = Files.readAllBytes(Paths.get(path));
		return new String(encoded, encoding);
	}

}


