package configgui.fi_jn;

import com.google.gson.JsonObject;

import javafx.beans.property.SimpleDoubleProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.scene.control.CheckBox;
import javafx.scene.control.TableCell;

public class FaultInjectionTableEntry{
	private SimpleStringProperty BananaIP;

	private SimpleDoubleProperty BFPercentage;
	private SimpleStringProperty BFDistributionInput;
	private SimpleStringProperty BFDistribution;
	private SimpleStringProperty BFRange;
	private SimpleIntegerProperty BFMean;
	private SimpleDoubleProperty BFStandardDeviation;
	private SimpleDoubleProperty BFLambda;
	
	private SimpleDoubleProperty WFPercentage;
	private SimpleStringProperty WFPortSet;
	private int					 WFPortSetInt;
	
	private SimpleDoubleProperty DuplicationPercentage;
	private SimpleStringProperty DuplicationDistributionInput;
	private SimpleStringProperty DuplicationDistribution;
	private SimpleStringProperty DuplicationRange;
	private SimpleIntegerProperty DuplicationMean;
	private SimpleDoubleProperty DuplicationStandardDeviation;
	private SimpleDoubleProperty DuplicationLambda;
	
	private SimpleDoubleProperty OmissionPercentage;
	
	private SimpleDoubleProperty CrashPercentage;
	
	private SimpleDoubleProperty DelayPercentage;
	private SimpleStringProperty DelayDistributionInput;
	private SimpleStringProperty DelayDistribution;
	private SimpleStringProperty DelayRange;
	private SimpleIntegerProperty DelayMean;
	private SimpleDoubleProperty DelayStandardDeviation;
	private SimpleDoubleProperty DelayLambda;
	
	private CheckBox ByzantineBehaviour;
	
	//Konstruktor mit Default Werten
	public FaultInjectionTableEntry(String bannanaip) {
		this.BananaIP = new SimpleStringProperty(bannanaip);
		
		this.BFPercentage= new SimpleDoubleProperty(0);
		this.BFDistributionInput = new SimpleStringProperty("U(0,0)");
		this.BFDistribution = new SimpleStringProperty("discrete_equal_distribution");
		this.BFRange = new SimpleStringProperty("0-0");
		this.BFMean = new SimpleIntegerProperty(0);
		this.BFStandardDeviation = new SimpleDoubleProperty(0);
		this.BFLambda = new SimpleDoubleProperty(0);
		
		this.WFPercentage = new SimpleDoubleProperty(0);
		this.WFPortSet = new SimpleStringProperty("{1,2,3,4}");
		this.WFPortSetInt =15;
		
		this.DuplicationPercentage= new SimpleDoubleProperty(0);
		this.DuplicationDistributionInput = new SimpleStringProperty("U(0,0)");
		this.DuplicationDistribution = new SimpleStringProperty("discrete_equal_distribution");
		this.DuplicationRange = new SimpleStringProperty("0-0");
		this.DuplicationMean = new SimpleIntegerProperty(0);
		this.DuplicationStandardDeviation = new SimpleDoubleProperty(0);
		this.DuplicationLambda = new SimpleDoubleProperty(0);
		
		this.OmissionPercentage = new SimpleDoubleProperty(0);
		
		this.CrashPercentage = new SimpleDoubleProperty(0);
		
		this.DelayPercentage = new SimpleDoubleProperty(0);
		this.DelayDistributionInput= new SimpleStringProperty("U(0,0)");
		this.DelayDistribution= new SimpleStringProperty("discrete_equal_distribution");
		this.DelayRange = new SimpleStringProperty("0-0");
		this.DelayMean = new SimpleIntegerProperty(0);
		this.DelayStandardDeviation = new SimpleDoubleProperty(0);
		this.DelayLambda = new SimpleDoubleProperty(0);

		this.ByzantineBehaviour = new CheckBox();
	}
	
	public FaultInjectionTableEntry(
			String bannanaip ,  
			double bfpercentage, String bfdistribution, String bfrange, int bfMean, double bfstandarddeviation,
			double wfpercentage, String wfportset,
			double duplicationpercentage, String duplicationdistribution, String duplicationrange, int duplicationMean, double duplicationstandarddeviation,
			double omissionPercentage,
			double crashpercentage,
			double delaypercentage, String delaydistribution, String delayrange, int delayMean, double delaystandarddeviation) 
	{
		this.BananaIP = new SimpleStringProperty(bannanaip);
		
		this.BFPercentage = new SimpleDoubleProperty(bfpercentage);
		this.BFDistributionInput = new SimpleStringProperty("U(0,0)");
		this.BFDistribution= new SimpleStringProperty(bfdistribution);
		this.BFRange = new SimpleStringProperty(bfrange);
		this.BFMean = new SimpleIntegerProperty(bfMean);
		this.BFStandardDeviation = new SimpleDoubleProperty(bfstandarddeviation);
		this.BFLambda = new SimpleDoubleProperty(0);
		
		this.WFPercentage = new SimpleDoubleProperty(wfpercentage);
		this.WFPortSet= new SimpleStringProperty(wfportset);
		
		this.DuplicationPercentage = new SimpleDoubleProperty(duplicationpercentage);
		this.DuplicationDistributionInput = new SimpleStringProperty("U(0,0)");
		this.DuplicationDistribution= new SimpleStringProperty(duplicationdistribution);
		this.DuplicationRange = new SimpleStringProperty(duplicationrange);
		this.DuplicationMean = new SimpleIntegerProperty(duplicationMean);
		this.DuplicationStandardDeviation = new SimpleDoubleProperty(duplicationstandarddeviation);
		this.DuplicationLambda = new SimpleDoubleProperty(0);
		
		this.OmissionPercentage = new SimpleDoubleProperty(omissionPercentage);
		
		this.CrashPercentage = new SimpleDoubleProperty(crashpercentage);
		
		this.DelayPercentage = new SimpleDoubleProperty(delaypercentage);
		this.DelayDistributionInput= new SimpleStringProperty("U(0,0)");
		this.DelayDistribution= new SimpleStringProperty(delaydistribution);
		this.DelayRange = new SimpleStringProperty(delayrange);
		this.DelayMean = new SimpleIntegerProperty(delayMean);
		this.DelayStandardDeviation = new SimpleDoubleProperty(delaystandarddeviation);
		this.DelayLambda = new SimpleDoubleProperty(0);

		this.ByzantineBehaviour = new CheckBox();
	}

	public JsonObject FaultInjectiontempToJson() {
		JsonObject a = new JsonObject();
		return a;
	}

	
	//getter and setter werden auch zum befuellen der Tabelle benötigt 
	public String getBananaIP() {
		return BananaIP.get();
	}

	public void setBananaIP(String bananaIP) {
		BananaIP.set(bananaIP);
	}
	
	//BF
	public double getBFPercentage() {
		return BFPercentage.get();
	}
	public void setBFPercentage(Double bfPercentage) {
		BFPercentage.set(bfPercentage);
	}
	
	public String getBFDistributionInput() {
		return BFDistributionInput.get();
	}
	public void setBFDistributionInput(String bfDistributioninput) {
		BFDistributionInput.set(bfDistributioninput);
	}
	
	public String getBFDistribution() {
		return BFDistribution.get();
	}
	public void setBFDistribution(String bfDistribution) {
		BFDistribution.set(bfDistribution);
	}

	public String getBFRange() {
		return BFRange.get();
	}
	public void setBFRange(String bfRange) {
		BFRange.set(bfRange);
	}
	
	public int getBFMean() {
		return BFMean.get();
	}
	public void setBFMean(int bfMean) {
		BFMean.set(bfMean);
	}
	
	public double getBFStandardDeviation() {
		return BFStandardDeviation.get();
	}
	public void setBFStandardDeviation(double bfStandardDeviation) {
		BFStandardDeviation.set(bfStandardDeviation);
	}

	public double getBFLambda() {
		return BFLambda.get();
	}
	public void setBFLambda(double bfLambda) {
		BFLambda.set(bfLambda);
	}
		
	//WF
	public double getWFPercentage() {
		return WFPercentage.get();
	}
	public void setWFPercentage(double wfPercentage) {
		WFPercentage.set(wfPercentage);
	}
	
	public String getWFPortSet() {
		return WFPortSet.get();
	}
	public void setWFPortSet(String wfPortSet) {
		WFPortSet.set(wfPortSet);
	}
		
	public int getWFPortSetInt() {
		return WFPortSetInt;
	}

	public void setWFPortSetInt(int wFPortSetInt) {
		WFPortSetInt = wFPortSetInt;
	}
	//Duplication
	public double getDuplicationPercentage() {
		return DuplicationPercentage.get();
	}
	public void setDuplicationPercentage(Double duplicationPercentage) {
		DuplicationPercentage.set(duplicationPercentage);
	}
	
	public String getDuplicationDistributionInput() {
		return DuplicationDistributionInput.get();
	}
	public void setDuplicationDistributionInput(String duplicationDistributionInput) {
		DuplicationDistributionInput.set(duplicationDistributionInput);
	}
	
	public String getDuplicationDistribution() {
		return DuplicationDistribution.get();
	}
	public void setDuplicationDistribution(String duplicationDistribution) {
		DuplicationDistribution.set(duplicationDistribution);
	}
	
	public String getDuplicationRange() {
		return DuplicationRange.get();
	}
	public void setDuplicationRange(String duplicationRange) {
		DuplicationRange.set(duplicationRange);
	}
	
	public int getDuplicationMean() {
		return DuplicationMean.get();
	}
	public void setDuplicationMean(int duplicationMean) {
		DuplicationMean.set(duplicationMean);
	}
	
	public double getDuplicationStandardDeviation() {
		return DuplicationStandardDeviation.get();
	}
	public void setDuplicationStandardDeviation(double duplicationStandardDeviation) {
		DuplicationStandardDeviation.set(duplicationStandardDeviation);
	}
	
	public double getDuplicationLambda() {
		return DuplicationLambda.get();
	}
	public void setDuplicationLambda(double duplicationLambda) {
		DuplicationLambda.set(duplicationLambda);
	}
	//Omission
	public double getOmissionPercentage() {
		return OmissionPercentage.get();
	}
	public void setOmissionPercentage(Double omissionPercentage) {
		OmissionPercentage.set(omissionPercentage);
	}

	
	//Crash
	public double getCrashPercentage() {
		return CrashPercentage.get();
	}
	public void setCrashPercentage(Double crashpercentage) {
		CrashPercentage.set(crashpercentage);
	}
	
	//Delay
	public double getDelayPercentage() {
		return DelayPercentage.get();
	}
	public void setDelayPercentage(double delayPercentage) {
		DelayPercentage.set(delayPercentage);
	}
	
	public String getDelayDistributionInput() {
		return DelayDistributionInput.get();
	}
	public void setDelayDistributionInput(String delayDistributionInput) {
		DelayDistributionInput.set(delayDistributionInput);
	}
	
	public String getDelayDistribution() {
		return DelayDistribution.get();
	}
	public void setDelayDistribution(String delayDistribution) {
		DelayDistribution.set(delayDistribution);
	}
	
	public String getDelayRange() {
		return DelayRange.get();
	}
	public void setDelayRange(String delayRange) {
		DelayRange.set(delayRange);
	}

	public int getDelayMean() {
		return DelayMean.get();
	}
	public void setDelayMean(int delayMean) {
		DelayMean.set(delayMean);
	}
	
	public double getDelayStandardDeviation() {
		return DelayStandardDeviation.get();
	}
	public void setDelayStandardDeviation(double delayStandardDeviation) {
		DelayStandardDeviation.set(delayStandardDeviation);
	}
	
	public double getDelayLambda() {
		return DelayLambda.get();
	}
	public void setDelayLambda(double delayLambda) {
		DelayLambda.set(delayLambda);
	}
	
	//ByzantineBehaviour
	public CheckBox getByzantineBehaviour() {
		return ByzantineBehaviour;
	}
	public void setByzantineBehaviour(CheckBox byzantineBehaviour) {
		this.ByzantineBehaviour = byzantineBehaviour;
	}

}
