package configgui.java.commands.chains;

import configgui.java.Rcc;
import configgui.java.commands.Command;
import configgui.java.commands.simple.UploadCommand;
import configgui.java.model.configuration.BananaInformation;
import javafx.collections.ObservableList;

public class UpdateLib extends Command {

	ObservableList<BananaInformation> bananas;

	public UpdateLib(ObservableList<BananaInformation> bananas) {
		this.bananas = bananas;
	}

	@Override
	public void executeCommand() {
		Rcc.ctrlMsgListener.registerCommandThread(getCmdId(), this);

		Rcc.out.terminalPrintln("Start updating GlobalBpiLib.\n", 1);

		Command.appendNextCommandToCommandchain();
		Rcc.out.terminalPrint("Uploading GlobalBpiLib ... ", 1);
		new UploadCommand(bananas, "GlobalBpiLib").exec().waitForTermination();

		for (BananaInformation banana : bananas) {
			Rcc.out.bananaOutPrintln(banana, "> " + "bpi cleanlib");
			banana.sendMessage("cleanlib" + " " + getCmdId());
		}
		Rcc.out.terminalPrint("Cleaning GlobalBpiLib ... ", 1);
		Boolean result = awaitStat(bananas, 30 * 1000, false);
		try {
			Rcc.out.terminalPrintln(result == null ? "[TIMEOUT]" : (result ? " [OK]" : " [NO]"), 0);
		} catch (Exception e) {
			e.printStackTrace();
		}

		for (BananaInformation banana : bananas) {
			Rcc.out.bananaOutPrintln(banana, "> " + "bpi compilelib");
			banana.sendMessage("compilelib" + " " + getCmdId());
		}
		Rcc.out.terminalPrint("Building GlobalBpiLib ... ", 1);
		result = awaitStat(bananas, 600 * 1000, false);
		try {
			Rcc.out.terminalPrintln(result == null ? "[TIMEOUT]" : (result ? " [OK]" : " [NO]"), 0);
		} catch (Exception e) {
			e.printStackTrace();
		}

		Rcc.ctrlMsgListener.deregisterCommandThread(getCmdId(), this);
	}

	@Override
	public boolean validate() {
		return true;
	}
}
