package configgui.java.commands.simple;

import configgui.java.Rcc;
import configgui.java.commands.Command;

public class GetOptionCommand extends Command {

	private String option;

	public GetOptionCommand(String opt) {
		option = opt;
	}

	@Override
	protected void executeCommand() {
		if (option == null) {
			Rcc.out.terminalPrintln(Rcc.configuration.getConfigurationAsJson(), 1);
		} else {
			String value = Rcc.configuration.getConfigEntry(option);
			if (value != null) {
				Rcc.out.terminalPrintln("\"" + option + "\"" + ": " + "\"" + value + "\"", 1);
			} else {
				Rcc.out.terminalPrintln("No option called " + option + " available.", 1);
			}
		}
	}

	@Override
	public boolean validate() {
		return Rcc.out != null && Rcc.configuration != null;
	}

}
