package configgui.java.commands.simple;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;

import configgui.java.Rcc;
import configgui.java.commands.Command;
import configgui.java.util.terminal.GeneralOutputInterface;

public class HelpCommand extends Command {

	private String opt; // XXX @author CS
	private String helpString;

	public HelpCommand(String opt) {
		this.opt = opt;
		try {
			helpString = readFile("src/configgui/resources/readmes/help", StandardCharsets.UTF_8);
		} catch (IOException e) {
			Rcc.out.addException(e);
		}
	}

	@Override
	protected void executeCommand() {
		if (opt == null) {
			Rcc.out.terminalPrintln(helpString, 1);
		} else {
			try {
				helpString = readFile("src/configgui/resources/readmes/" + opt, StandardCharsets.UTF_8);
				Rcc.out.terminalPrintln(helpString, 1);
			} catch (IOException e) {
				Rcc.out.addException(e);
				Rcc.out.terminalPrintln("Missing readme '" + opt + "'", 1);
			}
		}
	}

	@Override
	public boolean validate() {
		return Rcc.out != null;
	}

	static String readFile(String path, Charset encoding) throws IOException {
		byte[] encoded = Files.readAllBytes(Paths.get(path));
		return new String(encoded, encoding);
	}

}
