package configgui.java.commands.simple;

import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;

import configgui.java.Rcc;
import configgui.java.commands.Command;
import javafx.application.Platform;

public class RunExternalBashScript extends Command {

	File script;
	String ipfile;

	public RunExternalBashScript(File script, String ipfile) {
		this.script = script;
		this.ipfile = ipfile;
	}

	@Override
	protected void executeCommand() {
		Platform.runLater(() -> Rcc.out.getTerminal().deleteInput());
		Platform.runLater(() -> Rcc.out.terminalPrintln("External Script execution started: " + script.getName()));
		try {
			ProcessBuilder pb = new ProcessBuilder(script.getAbsolutePath(), ipfile, Rcc.configuration.getRemotePassword());
			pb.directory(new File(script.getParentFile().getAbsolutePath()));

			Process p = pb.start();
			BufferedReader out = new BufferedReader(new InputStreamReader(p.getInputStream()));
			String line = null;
			while ((line = out.readLine()) != null) {
				final String l = line;
				Platform.runLater(() -> Rcc.out.terminalPrintln(l, 1));
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		Platform.runLater(() -> Rcc.out.terminalPrintln("\nScript execution finished", 1));
	}

	@Override
	public boolean validate() {
		return true;
	}

}
