package configgui.java.commands.simple;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import configgui.java.Rcc;
import configgui.java.commands.Command;
import configgui.java.model.configuration.BananaInformation;
import javafx.collections.ObservableList;

public class ScanCommand extends Command {

	private ObservableList<BananaInformation> bananas;

	public ScanCommand(ObservableList<BananaInformation> bananas) {
		this.bananas = bananas;
	}

	@Override
	protected void executeCommand() {
		sendBroadcast(Rcc.configuration.getTargetNetwork());
		Rcc.out.statusSetText("Scan finished");
	}

	private boolean sendBroadcast(String ipString) {
		try {
			DatagramSocket clientSocket = new DatagramSocket();
			InetAddress ip = InetAddress.getByName(ipString);
			byte[] topo = new byte[] { 0x12, 0x34 };
			DatagramPacket dp = new DatagramPacket(topo, topo.length, ip, Rcc.configuration.getPort());
			clientSocket.send(dp);
			clientSocket.close();
		} catch (Exception e) {
			Rcc.out.addException(e);
			return false;
		}
		Rcc.out.terminalPrintln("Connection request sent to " + ipString, 1);
		return true;
	}

	@Override
	public boolean validate() {
		if (Rcc.out == null || Rcc.configuration == null) {
			return false;
		}
		if (Rcc.configuration.getTargetNetwork() == null) {
			Rcc.out.terminalPrintln("Please specify broadcast address.", 1);
			return false;
		}
		return bananas != null;
	}

}
