package configgui.java.controller;

import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

/**
 * Controls the Stage in which you could add a new key-value-pair to your
 * configurations.
 * 
 * @author Constantin Schulte
 */
public class CreateConfigController {

	private Stage stage;
	private ConfigWindowController tabController;

	@FXML
	private TextField key;
	@FXML
	private TextField value;

	/**
	 * Adds the new pair to the TabController and closes the Stage.
	 */
	@FXML
	private void add() {
		tabController.addConfiguration(key.getText(), value.getText());
		stage.close();
	}

	public void setStage(Stage stage) {
		this.stage = stage;
	}

	public void setTabController(ConfigWindowController controller) {
		this.tabController = controller;
	}
}
