package configgui.java.controller;

import java.util.HashMap;

import configgui.java.model.cells.ExceptionInformationCell;
import configgui.java.util.terminal.DetailsTextArea;
import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.fxml.FXML;
import javafx.scene.control.ListView;
import javafx.scene.layout.GridPane;

//XXX @author CS
public class ExceptionTabController {

	@FXML
	private ListView<GridPane> nodes;
	@FXML
	private GridPane gp;

	private DetailsTextArea details;
	private HashMap<GridPane, ExceptionInformationCell> map;

	public void initialize() {
		details = new DetailsTextArea();
		gp.add(details, 0, 0);
		map = new HashMap<>();
		nodes.getSelectionModel().selectedItemProperty().addListener(new ChangeListener<GridPane>() {
			@Override
			public void changed(ObservableValue<? extends GridPane> arg0, GridPane arg1, GridPane arg2) {
				if (map.get(arg2).getException() != null) {
					String stackTrace = map.get(arg2).getException().toString();
					for (StackTraceElement stackElement : map.get(arg2).getException().getStackTrace()) {
						stackTrace += "\n\tat " + stackElement.getClassName() + "." + stackElement.getMethodName();
						stackTrace += " line: " + stackElement.getLineNumber();
					}
					details.setText(stackTrace);
				}
			}
		});
	}

	public void addException(Exception e) {
		ExceptionInformationCell cell = new ExceptionInformationCell(e);
		map.put(cell.getDetailsPane(), cell);
		Platform.runLater(() -> nodes.getItems().add(cell.getDetailsPane()));
	}
}
