package configgui.java.model.configuration;

import configgui.java.util.BpiUtil;
import javafx.beans.binding.Bindings;
import javafx.beans.property.SimpleStringProperty;

public class OutputEvent {

	private final String rawTime;
	private final SimpleStringProperty src;
	private final SimpleStringProperty time;
	private final SimpleStringProperty timeshort;
	private final SimpleStringProperty msg;

	public OutputEvent(String s, String m) {
		src = new SimpleStringProperty(s);
		rawTime = "";
		time = new SimpleStringProperty("");
		timeshort = new SimpleStringProperty("");
		timeshort.bind(Bindings.createStringBinding(() -> time.get().substring(0, Math.min(time.get().length(), 8)), time));
		msg = new SimpleStringProperty(m);
	}

	public OutputEvent(String s, String t, String m) {
		src = new SimpleStringProperty(s);
		rawTime = t;
		String timeFormatted = "";
		try {
			timeFormatted = (BpiUtil.timeconvert_us(Long.parseLong(t)));
		} catch (Exception e) {
		}
		time = new SimpleStringProperty(timeFormatted);
		msg = new SimpleStringProperty(m);
		timeshort = new SimpleStringProperty("");
		if (time.get() != null && time.get().length() > 0)
			timeshort.bind(Bindings.createStringBinding(() -> time.get().substring(time.get().indexOf(':') - 2, time.get().indexOf(':') + 6)));
		else
			timeshort.bind(Bindings.createStringBinding(() -> time.get()));
	}

	public String getSrc() {
		return src.get();
	}

	public String getTime() {
		return time.get();
	}

	public String getMsg() {
		return msg.get();
	}

	public void setSrc(String fSrc) {
		src.set(fSrc);
	}

	public void setTime(String fTime) {
		src.set(fTime);
	}

	public void setMsg(String fMsg) {
		msg.set(fMsg);
	}

	public void setTimeshort(String fTimeshort) {
		timeshort.set(fTimeshort);
	}

	public SimpleStringProperty srcProperty() {
		return src;
	}

	public SimpleStringProperty timeProperty() {
		return time;
	}

	public SimpleStringProperty msgProperty() {
		return msg;
	}

	public SimpleStringProperty timeshortProperty() {
		return timeshort;
	}

	public void appMsg(String newmsg) {
		setMsg(msg.get() + "\n" + newmsg);
	}
}
