package configgui.java.util.network;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;

import configgui.java.Rcc;

public class ServerThread implements Runnable {

	public static int numberofclients = 0;

	private Rcc main;
	private boolean stopRequested;
	private ServerSocket socket;

	public ServerThread(Rcc main) {
		this.main = main;
		stopRequested = false;
		try {
			socket = new ServerSocket(1550);
			socket.setSoTimeout(0);
		} catch (IOException e) {
			stopRequested = true;
		}
	}

	public void stopServer() {
		stopRequested = true;
		try {
			socket.close();
		} catch (Exception e) {
			// TODO: handle exception
		}
	}

	public void run() {
		Thread.currentThread().setName("Server Thread");
		while (!stopRequested) {
			try {

				if (socket == null) {
					System.err.println("Could not listen for connection requests! Close all other instance of this application and restart.");
					stopRequested = true;
				} else {
					Socket client = socket.accept();
					ClientThread c = new ClientThread(main, client);
					c.start();
				}
			} catch (SocketException e) {
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
