package configgui.java.util.tab;

import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.TabPane;
import javafx.scene.layout.AnchorPane;
import javafx.stage.Stage;

public class DockingTabContent {

	static int globalindex = 0;
	TabPane parentPane;
	String label;
	Parent content;
	ExtendedTab tab;
	Stage sepStage;
	AnchorPane pane;
	boolean docked = true;
	int myIndex;

	double width = 800, height = 450, xPos = -1, yPos = -1;

	public DockingTabContent(TabPane parentPane, String label) {
		this.parentPane = parentPane;
		this.label = label;
		this.content = null;
		this.myIndex = globalindex++;
		create();
	}

	public DockingTabContent(TabPane parentPane, String label, Parent content) {
		this.parentPane = parentPane;
		this.label = label;
		this.content = content;
		this.myIndex = globalindex++;
		create();
	}

	private void create() {
		sepStage = new Stage();
		sepStage.setOnCloseRequest(event -> {
			height = sepStage.getHeight();
			width = sepStage.getWidth();
			xPos = sepStage.getX();
			yPos = sepStage.getY();
			dockTab();
		});
		pane = new AnchorPane();
		Scene sepScene = new Scene(pane, width, height);
		sepScene.getStylesheets().add("/configgui/resources/css/mainstyle.css");
		sepScene.getStylesheets().add("/configgui/resources/css/syntax.css");
		sepStage.setScene(sepScene);
		sepStage.setTitle(label);

		tab = new ExtendedTab(this, label, content);
		dockTab();
	}

	public void undockTab() {
		docked = false;
		if (pane.getChildren().size() > 0)
			pane.getChildren().remove(0);
		pane.getChildren().add(content);
		if (xPos != -1 && yPos != -1) {
			sepStage.setX(xPos);
			sepStage.setY(yPos);
		}
		sepStage.setWidth(width);
		sepStage.setHeight(height);
		sepStage.show();
	}

	public void dockTab() {
		docked = true;
		tab.setContentInsideAnchorPane(content);
		for (int i = 0; i < parentPane.getTabs().size(); i++)
			if (myIndex < ((ExtendedTab) parentPane.getTabs().get(i)).getDockManager().getIndex()) {
				parentPane.getTabs().add(i, tab);
				return;
			}
		parentPane.getTabs().add(tab);
	}

	public void refreshContent(Parent content) {
		if (docked)
			tab.setContentInsideAnchorPane(content);
		else {
			pane.getChildren().remove(this.content);
			pane.getChildren().add(content);
		}
		this.content = content;
	}

	public ExtendedTab getTab() {
		return tab;
	}

	public int getIndex() {
		return myIndex;
	}

}
