package configgui.java.util.tab;

import javafx.scene.Node;
import javafx.scene.control.Label;
import javafx.scene.control.Tab;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.HBox;

public class ExtendedTab extends Tab {

	Label tabLabel, undockSymbol;
	Node content;
	AnchorPane pane;
	DockingTabContent dockManager;

	public ExtendedTab(DockingTabContent dockManager, String label, Node content) {
		super("");
		this.dockManager = dockManager;
		pane = new AnchorPane();
		setContentInsideAnchorPane(content);
		tabLabel = new Label(label);
		undockSymbol = new Label("\u21f1");
		tabLabel.getStyleClass().add("customlabel");
		undockSymbol.getStyleClass().add("buttonlabel");
		this.setText("  " + label);
		HBox labelbox = new HBox();
		labelbox.getChildren().add(tabLabel);
		labelbox.getChildren().add(undockSymbol);
		this.setGraphic(labelbox);
		this.setClosable(false);

		undockSymbol.setOnMouseClicked(event -> {
			this.getTabPane().getTabs().remove(this);
			dockManager.undockTab();
		});
	}

	public void setLabel(String s) {
		tabLabel.setText(s);
	}

	public void setContentInsideAnchorPane(Node content) {
		this.content = content;
		while (pane.getChildren().size() > 0)
			pane.getChildren().remove(0);
		if (content != null) {
			pane.getChildren().add(content);
			AnchorPane.setTopAnchor(content, 0.0);
			AnchorPane.setRightAnchor(content, 0.0);
			AnchorPane.setLeftAnchor(content, 0.0);
			AnchorPane.setBottomAnchor(content, 0.0);
		}
		setContent(pane);
	}

	public DockingTabContent getDockManager() {
		return dockManager;
	}
}
