package configgui.java.util.terminal;

import java.util.ArrayList;

import javafx.scene.control.ContextMenu;
import javafx.scene.control.MenuItem;

public class AutoCompletionContextBox {
	private ArrayList<String> cmds;
	private ContextMenu popUp;
	private Terminal terminal;

	public ArrayList<String> getCmds() {
		return cmds;
	}

	public void setCmds(ArrayList<String> cmds) {
		this.cmds = cmds;
	}

	public ContextMenu getPopUp() {
		return popUp;
	}

	public void setPopUp(ContextMenu popUp) {
		this.popUp = popUp;
	}

	public Terminal getTerminal() {
		return terminal;
	}

	public AutoCompletionContextBox(ArrayList<String> cmds, Terminal owner) {
		this(owner);
		this.cmds = cmds;
	}

	public AutoCompletionContextBox(Terminal owner) {
		this.terminal = owner;
		cmds = new ArrayList<String>();
		popUp = new ContextMenu();
	}

	public void show(String startedCommand) {
		popUp.getItems().clear();
		for (String cmd : cmds) {
			if (cmd.startsWith(startedCommand)) {
				MenuItem item = new MenuItem(cmd);
				item.setOnAction(e -> {
					terminal.sendCompletedCmd(item.getText());
					popUp.hide();
				});
				popUp.getItems().add(item);
			}
		}

		popUp.show(terminal.getController().getPrimaryStage());
	}

	public void hide() {
		popUp.getItems().clear();
		popUp.hide();
	}
}
