package configgui.java.util.terminal;

import configgui.java.model.configuration.OutputEvent;
import javafx.scene.control.TableRow;
import javafx.scene.control.TableView;
import javafx.scene.layout.Pane;
import javafx.util.Callback;

public class CustomTableView extends TableView<OutputEvent> {
	public CustomTableView() {
		super();

		this.setRowFactory(new Callback<TableView<OutputEvent>, TableRow<OutputEvent>>() {
			@Override
			public TableRow<OutputEvent> call(TableView<OutputEvent> param) {
				final TableRow<OutputEvent> row = new TableRow<OutputEvent>() {
					@Override
					protected void updateItem(OutputEvent row, boolean empty) {
						super.updateItem(row, empty);
						if (!empty && row != null && row.getSrc() != null && row.getSrc().length() >= 8) {
							String name = row.getSrc().substring(1, 7).trim().toLowerCase();
							getStyleClass().removeIf(s -> s.startsWith("BPI"));
							getStyleClass().add("BPI" + name);
							if (row.getSrc().charAt(0) == '\u2045')
								getStyleClass().add("BPIerror");
						}
					}
				};
				return row;
			}
		});

	}

	@Override
	public void resize(double width, double height) {
		super.resize(width, height);
		Pane header = (Pane) lookup("TableHeaderRow");
		header.setMinHeight(0);
		header.setPrefHeight(0);
		header.setMaxHeight(0);
		header.setVisible(false);
	}
}
