/*
 * FabanSimLib.cpp
 *
 *  Created on: 10.06.2020
 *      Author: valentin
 */

#include "FabanSimLib.h"

uint32_t rotateSignatureLeft(uint32_t sig) {
    if ((sig & (1 << 31)) != 0) {
        sig = (sig << 1) + 1;
    }
    else {
        sig = (sig << 1);
    }
    return sig;
}

uint32_t rotateSignatureRight(uint32_t sig) {
    if ((sig & 1) != 0) {
        sig = (sig >> 1) + (1 << 31);
    }
    else {
        sig = (sig >> 1);
    }
    return sig;
}

uint32_t oddMultiplication(uint32_t x, uint32_t y) {
    uint64_t z = ((uint64_t) x) * ((uint64_t) y);
    z = 2 * ((z << 32) >> 32) + (uint64_t) x + (uint64_t) y;
    return (uint32_t) z;
}

uint32_t calculateOddMulSignature(uint32_t crc, uint32_t p) {
    return oddMultiplication(crc, p);
}

bool validationOddMulSignature(uint32_t crc, uint32_t r, uint32_t q, uint32_t u) {
    return oddMultiplication(u, q) == oddMultiplication(crc, r);
}

uint32_t rotateSignatureLeft(uint32_t sig, uint8_t bits) {
    uint32_t s = sig;
    for (uint8_t i = 0; i < bits; i++) {
        s = rotateSignatureLeft(s);
    }
    return s;
}

uint32_t rotateSignatureRight(uint32_t sig, uint8_t bits) {
    uint32_t s = sig;
    for (uint8_t i = 0; i < bits; i++) {
        s = rotateSignatureRight(s);
    }
    return s;
}
