//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef __FABANSIMULATOR_ROUTING_H_
#define __FABANSIMULATOR_ROUTING_H_

#include <omnetpp.h>
#include "bridgeAdmin.h"

using namespace omnetpp;

namespace fabansimulator
::bridge {

    class Routing : public cSimpleModule
    {
    public:
        void refreshDisplay() const;
    private:
        BridgeAdmin* _bridgeadmin;
        int64_t _totalBits = 0;
        simtime_t _lastPacketReceivedTime = 0;
        std::map<uint16_t, std::vector<uint32_t>> accHistory;

        void _addAccHistory(uint16_t senderId, uint32_t sgn);
        bool _accHistoryContains(uint16_t senderId, uint32_t sgn);
        void _printHistory();
    protected:
        virtual void initialize();
        virtual void handleMessage(cMessage *msg);
        virtual void finish();
        int _suppressedMessages;
        cOutVector inputStream;

    };

}
//namespace

#endif
