//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef __FABANSIMULATOR_SINK_H_
#define __FABANSIMULATOR_SINK_H_

#include <omnetpp.h>
#include "nodeAdmin.h"

using namespace omnetpp;

namespace fabansimulator
::node {

    class Sink : public cSimpleModule
    {
    public:
        void refreshDisplay() const;

    protected:
        virtual void initialize();
        virtual void handleMessage(cMessage *msg);
        virtual void finish();

    private:
        NodeAdmin* _nodeadmin;
        std::map<uint16_t, std::vector<uint32_t>> accHistory;

        void _addAccHistory(uint16_t senderId, uint32_t sgn);
        bool _accHistoryContains(uint16_t senderId, uint32_t sgn);
        void _printHistory();

        // Statistics
        uint64_t _numRx;
        uint64_t _numDiscardedDelay;
        uint64_t _numDiscardedFaulty;
        uint64_t _numSuccessfulBc;
        uint64_t _numSuccessfulBcFromFaultyBridges;
        uint64_t _numFfDuplicates;
        cHistogram _rxTimes;
        cHistogram _rxTimesNormalized;
        cHistogram _diffToTd;
        cHistogram _numRxSender;
    };

}
//namespace

#endif
