//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef __FABANSIMULATOR_SOURCE_H_
#define __FABANSIMULATOR_SOURCE_H_

#define TXMODE_RATE 0
#define TXMODE_INTERVAL 1

#include <omnetpp.h>
#include "../../packets/fabMsg_m.h"
#include "../../packets/data_m.h"
#include "nodeAdmin.h"

using namespace omnetpp;

namespace fabansimulator
::node {

    class Source : public cSimpleModule {
    public:
        bool active;
        void refreshDisplay() const;

    protected:
        virtual void initialize();
        virtual void handleMessage(cMessage *msg);
        virtual void finish();

    private:
        NodeAdmin* nodeAdmin;
        std::string _newFabanMsgName();
        void _createRandomData(Data* dataMsg);
        double _nextTxTimePoint();
        uint64_t _numTx;
        uint8_t _txmode = -1;
        int _lastDatasize = 0;
        simtime_t _firstMsgSent = 0;
        uint64_t _totalBitSent = 0;
        double _datarate = 0;
        double _deltaBusy = 0;
        int _maxHops;
        int _maxDataSize;
    };

}
//namespace

#endif
