/*
 * FIProtocolLogic.h
 *
 *  Created on: Mar 5, 2019
 *      Author: jubuntu
 */

#ifndef FI_JN_FIPROTOCOLLOGIC_H_
#define FI_JN_FIPROTOCOLLOGIC_H_
#include "../Protocols/ProtocolLogic.h"
#include <chrono>

class FIProtocolLogic : public ProtocolLogic{
public:
	FIProtocolLogic();
	virtual ~FIProtocolLogic();
	virtual void sendMessage(EthernetMessage* msg, int outPorts, bool checkForDuplication = true);

protected:
	virtual void _handleControlMessageFI(std::string cmdId, std::string cmd);
	static void* _threadEntryFunction(void* voidArgs);
	void _threadTask(int);
	void sendingThreadTask(EthernetMessage* msg , int outPorts , int Delay);


private:
	enum  ProbabilityDistribution{
			discrete_equal_distribution,
			Gaussian_distribution,
			Exponential_distribution
		};
	EthernetMessage* createBFmsg(EthernetMessage* msg, int actualNumberOfBF); //returns a new EthMessage with the passed amount of BF it can happen, that the same Bit is flipped twice which would resolve in less BFs than passed

	ProbabilityDistribution StringToProbDist(std::string); //default value "discrete_equal_distribution"

	//###########	Bit Flips  #############//
	double bfPercentage 			= 0.0;
	ProbabilityDistribution bfProbabilitiyDistribution = discrete_equal_distribution;
	int bfRangeMin					= 0;
	int bfRangeMax					= 0;
	int bfMean						= 0; //steps of 0.1 seconds
	double bfStandardDeviation		= 0;
	double bfLambda					= 0;

	//###########   Wrong Forwarding  #############//
	double wfPercentage				= 0;
	int wfPortSet					= 0;

	//###########	Duplication		##############//
	double duplicationPercentage 			= 0.0;
	ProbabilityDistribution duplicationProbabilitiyDistribution = discrete_equal_distribution;
	int duplicationRangeMin					= 0;
	int duplicationRangeMax					= 0;
	int duplicationMean						= 0;
	double duplicationStandardDeviation		= 0;
	double duplicationLambda				= 0;

	//###########   Omission		#############//
	double omissionPercentage		= 0;

	//###########   Crash 	  		#############//
	bool crashed 					= false;
	double crashPercentage 			= 0;

	//###########   Delay  			#############//
	double delayPercentage			= 0.0;
	ProbabilityDistribution delayProbabilitiyDistribution = discrete_equal_distribution;
	int delayRangeMin				= 0;
	int delayRangeMax				= 0;
	int delayMean					= 0;
	double delayStandardDeviation	= 0;
	double delayLambda				= 0;

	//###########   ByzantineBehavior  #############//
	bool ByzantineBehavior			= false;

};

#endif /* FI_JN_FIPROTOCOLLOGIC_H_ */
