//============================================================================
// Name        : IoServiceVF.cpp
// Author      : VF
// Version     :
// Copyright   : Your copyright notice
// Description :
//============================================================================

#include <iostream>
#include <csignal>

#include "TcpInterface.h"
#include "LocalBpiLib.h"
#include "UdpConnector.h"

using namespace std;

int main(int argc, char** argv) {
	// Custom handling of the signal SIGTERM
	signal(SIGTERM, sigtermHandler);

	dout << "IoService started" << endl;
	std::string pathToLocalService(Configuration::getConfig(JSON_CONFIGFILE, "run_path"));
	dout << "Path to LocalService executable set to\"" << pathToLocalService << "\"" << endl;

	// Initialisation of a LsInterface and execution as concurrent thread
	LsInterface lsIntfce("LocalService", pathToLocalService);
	lsIntfce.start();

	// Initialisation of a TcpInterface and execution as concurrent thread
	TcpInterface tcpHandler(argv[0]);
	tcpHandler.setLsInterface(&lsIntfce);
	tcpHandler.start();

	// Initialisation of a UdpConnector and execution of an endless connection loop
	UdpConnector udpListener(&tcpHandler);
	udpListener.enterConnectionLoop();

	return 0;
}
