#include "LocalBpiLib.h"

#include <fcntl.h>
#include <iostream>
#include <vector>
#include <string>
#include <unistd.h>
#include <cstring>

#include <cstring>
#include <sstream>
#include <ctime>
#include <iostream>
#include <fstream>
#include <signal.h>
#include <limits.h>
#include <unistd.h>

#include "GlobalBpiLib.hpp"

using namespace std;

std::string createHash(std::string msg) {
	std::stringstream ss;
	ss << "\x06" << std::setfill('0') << std::setw(2) << std::hex << hashSum(msg) << std::setfill('0') << std::setw(2)
			<< (msg.length() % 256) << std::dec << "\x06";
	auto hash = ss.str();
	return hash;
}

uint8_t primeExp(int prime, int i) {
	int count = 1;
	int result = prime;
	while (count < i) {
		result = (result * prime) % 256;
		++count;
	}
	return (uint8_t) result;
}

uint8_t timesPrimeExpI(uint8_t c, int i) {
	int result = (c * primeExp(17, i)) % 256;
	return (uint8_t) result;
}

uint32_t hashSum(std::string msg) {
	uint32_t sum = 0;
	for (std::string::size_type i = 0; i < msg.length(); i++) {
		sum = (sum + timesPrimeExpI(msg[i], i)) % 256;
	}
	return sum;
}

void setFd(int* _fd) {
	fd = _fd;
}

int printErrToTcpConnection(std::string s) {
	if (fd != nullptr) {
		return writeToFileDescriptor(*fd, wrapInStxEtx(bpiGetNamestampErr(NAME).append(s)));
	} else
		return -1;
}

int printToTcpConnection(std::string s) {
	if (fd != nullptr) {
		return writeToFileDescriptor(*fd, wrapInStxEtx(bpiGetNamestamp(NAME).append(bpiGetTimestamp(Configuration::getConfig(JSON_CONFIGFILE, "clocksync")).append(s))));
	} else
		return -1;
}

std::string ackMessage(std::string msg) {
	return std::string("\u0006").append(msg).append("\u0006");
}

std::string wrapInStxEtx(std::string s) {
	return std::string("\u0002").append(s).append("\u0003");
}

std::vector<std::string> splitIntoMessages(std::string str) {
	vector<string> items;
	size_t pos;
	while (str.length() > 0 && (pos = str.find("\u0003", 0)) != string::npos) {
		items.push_back(str.substr(0, pos + 1));
		str = str.substr(pos + 1, string::npos);
	}
	if (str.size() > 0)
		items.push_back(str);
	return items;
}

int* getFd() {
	return fd;
}
