/**
 * @file
 *
 * Additional program specific definitions extending GlobalBpiLib.hpp.
 *
 * */

#ifndef LOCALBPILIB_H_
#define LOCALBPILIB_H_

#include "GlobalBpiLib.hpp"

#define JSON_CONFIGFILE "/home/user/Banananetwork/.config/ioconfig.json" /**< Path the the json file. */
#define NAME "IoServ" /**< Short Name of this project for generating namestamps. */
#define MAXINPUTLENGTH 128
#define CLOCKSYNCVALUECOUNT 5

#define SUPPRESS_LOCALMESSAGEPRINT_ALIVE true
#define SUPPRESS_LOCALMESSAGEPRINT true
#define SUPPRESS_LOCALACKMSGPRINT true
#define SUPPRESS_LOCALCOMMANDDEBUG true

static DebugOutStream dout(std::cout);
static DebugOutStream derr(std::cerr);

static int* fd = nullptr;

void setFd(int* _fd);
int* getFd();
int printErrToTcpConnection(std::string s);
int printToTcpConnection(std::string s);
std::string wrapInStxEtx(std::string s);
uint32_t hashSum(std::string msg);
std::string createHash(std::string msg); /**< Calculates the hash of the given string. Returns a pointer to a newly created buffer of size 4 containing the hash. */
std::string ackMessage(std::string msg);
std::vector<std::string> splitIntoMessages(std::string str);

#endif /* LOCALBPILIB_H_ */
