//============================================================================
// Name        : LocalService.cpp
// Author      : VF
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

/** @mainpage Local Service
 *
 *  @section sec1 Description
 *  This application realizes the core interface for remote controlling applications, written for the Banana Pi R1
 *  Microcontroller. This application realizes the core interface for remote controlling applications, written for
 *  the Banana Pi R1 Microcontroller. The aim of this implementation is to provide an easy way to develop fault
 *  tolerant protocols for the Banana Pi R1 and run realtime executions to achieve important results. This application
 *  is just a core part of a chain of tools, consisting of:
 *
 *	@li ConfigTool: Remote Tool written in Java
 *	@li I/O Service: Local Banana Pi R1 application written in C++
 *	@li <b>Local Service</b>: Local Banana Pi R1 application written in C++
 *	@li Protocols: Local Banana Pi R1 applications written in C++
 *
 */

#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <iostream>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <csignal>

#include "LocalBpiLib.h"
#include "InputHandler.h"

using namespace std;

int main(int argc, char* argv[]) {
	signal(SIGTERM, sigtermHandler);

//	if (argc > 1) {
//		if (strcmp(argv[1], "--version") == 0) {
//			cout << __DATE__ << " " << __TIME__ << endl;
//			return 0;
//		} else {
//			cout << "unknown Parameter: " << argv[1] << endl;
//			return 0;
//		}
//	}

	if (argc >= 2) {
		long long int timepoint = std::stoull(argv[1]);
		getLocalClock()->set(timepoint);
	}

	bpiSetName("LOCAL");

	setvbuf(stdout, NULL, _IOLBF, 0);
	setvbuf(stderr, NULL, _IOLBF, 0);

	BpiOutStream bpiout(cout);
	bpiout << "Local Service started..." << endl;

	InputHandler inHandler(argv[0]);
	inHandler.runLoop();

	return 0;
}
