#include <Protocols/ProtocolLogic.h>
#include "DemoInputHandler.h"
#include "DemoLogic.h"

CustomInputHandler::CustomInputHandler() {
	protocol = new CustomLogic();

	// Add protocol specific commands to the list of knownk commands
	commandList.push_back("sayhi");
	commandList.push_back("show");
	commandList.push_back("reset");
	commandList.push_back("setoutoff");
	commandList.push_back("setouton");
}

void CustomInputHandler::handleCommand(char* cmdIn) {
	std::string input(cmdIn);
	std::string command = bpiSplitIntoItems(input, ' ').at(0);

	for (auto s : commandList) {
		if (command.compare(s) == 0) {
			protocol->controlInput(input);
			return;
		}
	}
	bpierr << "Unknown command: \"" << input << "\"" << std::endl;
}

CustomInputHandler::~CustomInputHandler() {
}

