#include "DiscoveryLogic.h"
#include <Protocols/EtherTypes.h>
#include <Protocols/Port.h>
#include <Protocols/MessageTypes.h>
#include <string>
#include <iostream>

DiscoveryLogic::DiscoveryLogic() {
}

void DiscoveryLogic::_executeProtocolLogic() {
	for (auto msgit = protocol_messages.begin(); msgit != protocol_messages.end();) {
		EthernetMessage* message = *msgit;
		std::stringstream remMac;
		std::stringstream rxPort;
		std::stringstream txPort;
		auto msg = std::string(message->data->data);
		switch ((message)->ether_type) {
		case ETH_TYPE_DISCOVERY_REQUEST: {
			int port_index = ((EthMsgMeta*) message->meta)->port - 1;
			std::stringstream outPort;
			outPort << port_index + 1;
			Message* data = createMessageData(outPort.str().c_str(), 1, ETHDATAMIN);
			auto em = createEthernetMessage(_bc_mac, source_mac, ETH_TYPE_DISCOVERY_RESPONSE, data);
			ports[port_index]->addMessage(em);
		}
			break;
		case ETH_TYPE_DISCOVERY_RESPONSE:
			rxPort << "rx_" << ((EthMsgMeta*) message->meta)->port;
			txPort << "tx_" << message->data->data[0];
			remMac << macToString(6, message->source);
			bpiout << createCtrlMessage(4, cmdId.c_str(), rxPort.str().c_str(), remMac.str().c_str(), txPort.str().c_str()) << std::endl;
			break;
		default:
			break;
		}
		msgit = protocol_messages.erase(msgit);
	}
}

void DiscoveryLogic::_handleControlMessage(std::string id, std::string cmd) {
	this->cmdId = id;
	if (strncmp("discover", cmd.c_str(), 8) == 0) {
		bpiout << createCtrlMessage(3, cmdId.c_str(), "myMac", ports[0]->getLocalMacAddr().c_str()) << std::endl;
		for (int i = 0; i < 4; i++) {
			std::stringstream outPort;
			outPort << ports[i]->getPortId();
			Message* data = createMessageData(outPort.str().c_str(), outPort.str().size(), ETHDATAMIN);
			auto em = createEthernetMessage(_bc_mac, source_mac, ETH_TYPE_DISCOVERY_REQUEST, data);
			ports[i]->addMessage(em);
		}
	}
}

DiscoveryLogic::~DiscoveryLogic() {
}

