#include "FabanInputHandler.h"

#include <Protocols/ProtocolLogic.h>

#include "FabanLogic.h"

FabanInputHandler::FabanInputHandler() {
	protocol = new FabanLogic();

	// Add protocol specific commands to the list of knownk commands
	commandList.push_back("resetrouting");
	commandList.push_back("addroutinginfo");
	commandList.push_back("showconfiguration");
	commandList.push_back("ping");
	commandList.push_back("init");
	commandList.push_back("sendfabanmessage");
	commandList.push_back("addsgnpublic");
	commandList.push_back("addsgnprivate");
	commandList.push_back("setmasks");
	commandList.push_back("sender");
	commandList.push_back("showstats");
	commandList.push_back("resetstats");
	commandList.push_back("setlinkspeed");
}

void FabanInputHandler::handleCommand(char* cmdIn) {
	std::string input(cmdIn);
	std::string command = bpiSplitIntoItems(input, ' ').at(0);

	// TODO Testing Area |-->
//	bpiout << "Testing Area: " << std::endl;
//	FabanMessage* f = createFabanMessage(1, 2, 3, 4, "huhu");
//	bpiout << "Created Message: " << printMessage(f) << std::endl;
//	deleteFabanMessage(f);

// TODO <--|

	for (auto s : commandList) {
		if (command.compare(s) == 0) {
			protocol->controlInput(input);
			return;
		}
	}
	bpierr << "Unknown command: \"" << input << "\"" << std::endl;
}

void FabanInputHandler::_CommandStatus(std::string input) {
	protocol->controlInput(input);
//	bpiout << createCtrlMessage(2, "ID0001", "OK") << std::endl;
}

FabanInputHandler::~FabanInputHandler() {
}
