#ifndef SRC_FABANLOGIC_H_
#define SRC_FABANLOGIC_H_

#include "fi_jn/FIProtocolLogic.h"
#include "fi_jn/FIPort.h"
#include <chrono>

class FabanLogic: public FIProtocolLogic {
private:

	Port* _createPort(int i);
	void _executeProtocolLogic();
	void _handleControlMessage(std::string cmdId, std::string cmd);
	EthernetMessage* _sign(EthernetMessage* msg);
	bool _signaturetest(EthernetMessage* msg);
	uint32_t _oddMultiplication(uint32_t x, uint32_t y);
	bool _deliveryDeadlineCheck(FabanMessage* msg);
	void _deliverMessage(EthernetMessage* msg);
	EthernetMessage* _rotateSignatureRight(EthernetMessage* msg);
	int _contains(std::vector<uint8_t>, uint8_t);
	void _cleanLc(uint8_t id, uint8_t seq);
	int _dist(int a, int b);

	int _nodeId, _seqNo;
	std::map<uint8_t, std::map<int, std::vector<int>>> _routingtable;
	std::map<uint8_t, std::pair<uint32_t, uint32_t>> _publicsignaturekeys;
	uint32_t _sgnKeyP, _dMask, _cMask, _rMask;
	char _bc_mac[6];
	std::chrono::system_clock::time_point _startTime;

	static void* _senderThreadEntryFunction(void* This);
	void _senderThreadTask();
	void _sendFabanMessage();

	uint32_t senderNumMsg;
	double senderDelayMin;
	double senderDelayMax;

	uint8_t seqCounter1[256];
	uint8_t seqCounter2[256];
	uint32_t statRx;
	uint32_t statTx;
	uint32_t statRxFaulty;
	uint64_t statDeltaTd;
	uint64_t statDeltaTdSum;

	uint64_t statR;
	uint64_t statD;
	uint64_t statL;
	int x[256];
	int y[256];
	std::vector<uint8_t> lc[256];

public:
	FabanLogic();
	virtual ~FabanLogic();
};

#endif /* SRC_FABANLOGIC_H_ */
