#include <pcap.h>
#include <iostream>
#include <cstdlib>
#include <csignal>

using namespace std;

pthread_mutex_t m;

static int count = 0;

void my_callback(u_char *useless, const struct pcap_pkthdr* pkthdr, const u_char* packet) {
        pthread_mutex_lock(&m);
        count++;
        pthread_mutex_unlock(&m);
}

int main(int argc, char **argv) {
        auto lam = 
      [] (int i) { cout << "\n\nRX="<< count << endl; exit(0); };

    //^C
    signal(SIGINT, lam);
    //abort()
    signal(SIGABRT, lam);
    //sent by "kill" command
    signal(SIGTERM, lam);
    //^Z
    signal(SIGTSTP, lam);

        std::string dev_name = "eth0.2";
        if (argc > 1)
                dev_name = argv[1];
        cout << "Sniffing started on "<< dev_name << endl;
        char error_buffer[PCAP_ERRBUF_SIZE];
        pcap_t *pcap_port = pcap_open_live(dev_name.c_str(), 1518, 1, 0, error_buffer);
		
        if (pcap_setdirection(pcap_port, PCAP_D_IN) == -1) {
                cerr << "Could not specify port direction on device " << dev_name << std::endl;
                cerr << "This means outgoing traffic is treated as incoming traffic." << std::endl;
        }

        while (true) {
                //pcap_loop(pcap_port , -1 , my_callback , NULL);
                pcap_dispatch(pcap_port, 1, my_callback, NULL);
        }
        printf("After pcap_loop");
}


