package topology;

import java.util.ArrayList;
import java.util.Random;

@SuppressWarnings("serial")
public class Wave extends ArrayList<DirectedLink> {

	Topology network;
	Bridge d, c;
	ArrayList<Bridge> reachedBridges = new ArrayList<>();
	ArrayList<DirectedLink> nE = new ArrayList<>();
	int maxDistance = 0;

	public Wave(Topology t) {
		super();
	}

	public Wave(DirectedLink[] initialLinks) {
		super();
		for (DirectedLink l : initialLinks)
			this.add(l);
	}

	public Bridge getD() {
		return d;
	}

	public void setD(Bridge d) {
		this.d = d;
	}

	public Bridge getC() {
		return c;
	}

	public void setC(Bridge c) {
		this.c = c;
	}

	public boolean add(DirectedLink l) {
		reachedBridges.add((Bridge) l.b);
		return super.add(l);
	}

	public ArrayList<DirectedLink> refreshNE(ArrayList<DirectedLink> superset) {
		nE.clear();
		for (DirectedLink l : superset) {
			if (reachedBridges.contains(l.a) && !reachedBridges.contains(l.b))
				nE.add(l);
		}
		return nE;
	}

	public DirectedLink selectRandomEdge(String mode) {
		if (mode.equals("uniform")) {
			Random rand = new Random();
			return nE.get(rand.nextInt(nE.size()));
		} else
			return nE.get(0);
	}

	public void print() {
		System.out.println("    DB: " + d.name + "\tCB: " + c.name);
		System.out.print("    ");
		for (DirectedLink l : this) {
			System.out.print(l.toString() + " | ");
		}
		System.out.println("\n");
	}

	public void setMaxDistance(int maxDistance) {
		this.maxDistance = maxDistance;
	}

	public int getMaxDistance() {
		return maxDistance;
	}
}
